<id>
Link IP for YaBB 2.4
</id>

<version>
1.1a
</version>

<mod info>
Description
-----------
This mod will turn IP addresses in Board Index, Message View, Member Profiles, Instant Messages, View Poll Votes, Forum Log, Error Log and Registration Log from regular text into links that will connect to IP Tracker Websites.

Installation
------------
1) Modify YaBB files using BoardMod or manually.
2) Upload modified files to your server in ASCII mode.
3) Upload LinkIP.lng to the Languages directory, and LinkIPSettings.pl to the Admin directory in ASCII mode.
4) Go into the Link IP Settings area in the Admin Center to configure the settings.

Files to edit
-------------
AdminIndex.pl
Admin/Admin.pl
Admin/AdminSubList.pl
Admin/ErrorLog.pl
Admin/ModList.pl
Admin/RegistrationLog.pl
Languages/English/Admin.lng
Sources/BoardIndex.pl
Sources/Display.pl
Sources/InstantMessage.pl
Sources/Poll.pl
Sources/Profile.pl

Version History
---------------
### YaBB 2.4 ###
1.0 - Upadted by Derek Barnstorm - 4th December 2009
1.1 - Added to Instant Messages, Registation Log and Admin Edits - 7th December 2009
1.1a - Added to View Poll Votes - 7th December 2009

### YaBB 2.0/1 ###
1.0 - 1.2 - Original Mod by Brian Longo 
</mod info>

<author>
Brian Longo
</author>

<homepage>
http://boardmod.org
</homepage>

<edit file>
AdminIndex.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
$linkip_mod = "linkip|$mod_list{'linkip'}|$mod_list{'linkip1'}|";
push (@boardmod_mods, "$linkip_mod");
</add before>

<edit file>
Admin/Admin.pl
</edit file>

<search for>
		if ($newiplist[$i]->[0] =~ /\S+/ && $newiplist[$i]->[0] =~ /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/) {
			$guestiplist .= qq~$newiplist[$i]->[0]&nbsp;<span style="color: #FF0000;">(<i>$newiplist[$i]->[1]</i>)</span><br />~;
</search for>

<replace>
	    ### Link Ip Mod Start ###
	    if (-e("$vardir/link_ip.txt")) { require "$vardir/link_ip.txt"; }
	    if ($linkip_fl) {
   		    $iplink = qq~<a href="$ip_util$newiplist[$i]->[0]" target="_blank" style="text-decoration: underline;">$newiplist[$i]->[0]</a>~;
   		} else {
   		    $iplink = qq~$newiplist[$i]->[0]~;
   		}
   		### Link IP Mod End ###
		if ($newiplist[$i]->[0] =~ /\S+/ && $newiplist[$i]->[0] =~ /\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/) {
			$guestiplist .= qq~$iplink&nbsp;<span style="color: #FF0000;">(<i>$newiplist[$i]->[1]</i>)</span><br />~; ### Link IP Mod Edit ###
</replace>

<edit file>
Admin/AdminSubList.pl
</edit file>

<search for>
'ipban3',"Admin.pl&ipban_update",
</search for>

<add after>
'linkip',"LinkIPSettings.pl&LinkIP",  ### Link IP Mod ###
'linkip2',"LinkIPSettings.pl&LinkIP2",  ### Link IP Mod ###
</add after>

<edit file>
Admin/ErrorLog.pl
</edit file>

<search for>
		if ($tmp_user eq "$useraccount{$tmp_user}") {
			if ($userprofile{$tmp_user}->[1]) {
				$username = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmp_user}" target ="_blank">$userprofile{$tmp_user}->[1]</a>~;
			} else {
				$username .= qq~$useraccount{$tmp_user}~;
			}
			$username .= qq~<br />($tmp_userip)~;
		} else {
			$username = qq~$tmp_user<br />($tmp_userip)~;
		}
</search for>

<replace>
		### Link Ip Mod Start ###
		if (-e("$vardir/link_ip.txt")) { require "$vardir/link_ip.txt"; }
		if ($linkip_el) {
		    $iplink = qq~<a href="$ip_util$tmp_userip" target="_blank" style="text-decoration: underline;">$tmp_userip</a>~;		
        } else {
            $iplink = $tmp_userip;
        }
        ### Link IP Mod End ###
		if ($tmp_user eq "$useraccount{$tmp_user}") {
			if ($userprofile{$tmp_user}->[1]) {
				$username = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmp_user}" target ="_blank">$userprofile{$tmp_user}->[1]</a>~;
			} else {
				$username .= qq~$useraccount{$tmp_user}~;
			}
			$username .= qq~<br />($iplink)~; ### Link IP Mod Edit ###
		} else {
			$username = qq~$tmp_user<br />($iplink)~; ### Link IP Mod Edit ###
		}
</replace>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
	$linkip_mod = "Link IP|Brian Longo|This mod will turn IP addresses in Board Index, Message View, Member Profiles, Instant Messages, View Poll Votes, Forum Log, Error Log and Registration Log from regular text into links that will connect to IP Tracker Websites. (<span class=\"small\"><b><a href=\"$adminurl?action=linkip\" >Link IP Settings</a></b></span>)|1.1a|7th December 2009";
	push (@installed_mods, "$linkip_mod");
</add before>

<edit file>
Admin/RegistrationLog.pl
</edit file>

<search for>
	$yymain .= qq~<tr class="windowbg">
   <td width="320" align="left"><b>$prereg_txt{'apr_language'}: </b></td>
</search for>

<add before>
	### Link IP Mod Start ###
	if (-e("$vardir/link_ip.txt")) { require "$vardir/link_ip.txt"; }
    if ($linkip_rl) { $iplink = qq~<a href="$ip_util${$uid.$readuser}{'lastips'}" target="_blank" style="text-decoration: underline;">${$uid.$readuser}{'lastips'}</a>~; } 
    else { $iplink = qq~${$uid.$readuser}{'lastips'}~; }
    ### Link IP Mod End ###
</add before>

<search for>
   <td align="left">${$uid.$readuser}{'lastips'}</td>
</search for>

<replace>
   <td align="left">$iplink</td>
</replace>

<edit file>
Languages/English/Admin.lng
</edit file>

<search for>
);

%smtp_txt = (
</search for>

<add before>
'linkip' => 'Link IP Settings',
'linkip1' => 'Edit Link IP Settings',
</add before>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
		if (!$last_ip) { $last_ip = qq~</i></span><span class="error">$boardindex_txt{'no_ip'}</span><span class="small"><i>~; }
</search for>

<add after>
	    ### Link IP Mod Start ###
	    if (-e("$vardir/link_ip.txt")) { require "$vardir/link_ip.txt"; }
	    if ($linkip_bi && $last_ip) { $iplink = qq~<a href="$ip_util$last_ip" target="_blank" style="text-decoration: underline;">$last_ip</a>~; } 
	    else { $iplink = $last_ip; }
		### Link IP Mod End ###
</add after>

<search for>
					$users .= (${$uid.$name}{'stealth'} ? "*" : "") .
					          ((($iamadmin && $show_online_ip_admin) || ($iamgmod && $show_online_ip_gmod)) ? "&nbsp;<i>($last_ip)</i>, " : ", ");
</search for>

<replace>
					$users .= (${$uid.$name}{'stealth'} ? "*" : "") .
					          ((($iamadmin && $show_online_ip_admin) || ($iamgmod && $show_online_ip_gmod)) ? "&nbsp;<i>($iplink)</i>, " : ", "); ### Link IP Mod Edit ###
</replace>

<search for>
					$guestlist .= qq~<i>$last_ip</i>, ~;
</search for>

<replace>
				    ### Link IP Mod Edit Start ###
			        if ($linkip_bi) { $guestlist .= qq~<i>$iplink</i>, ~; } 
					else { $guestlist .= qq~<i>$last_ip</i>, ~; }
					### Link IP Mod Edit End ###
</replace>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		if ($iamadmin || $iamgmod && $gmod_access2{'ipban2'} eq "on") { $mip = $mip }
</search for>

<replace>
		### Link IP Mod Start ###
		if (-e("$vardir/link_ip.txt")) { require "$vardir/link_ip.txt"; }
        if ($linkip_mv) {
            ($mip_one, $mip_two, $mip_three) = split(/ /, $mip);	
	        if ($mip_one) { $iplink = qq~<a href="$ip_util$mip_one" target="_blank" style="text-decoration: underline;">$mip_one</a> ~; } 
            if ($mip_two) { $iplink .= qq~<a href="$ip_util$mip_two" target="_blank" style="text-decoration: underline;">$mip_two</a> ~; } 
            if ($mip_three) { $iplink .= qq~<a href="$ip_util$mip_three" target="_blank" style="text-decoration: underline;">$mip_three</a>~; } 
        } else {
            $iplink = $mip;
        }
        ### Link IP Mod End ###
        if ($iamadmin || $iamgmod && $gmod_access2{'ipban2'} eq "on") { $mip = $iplink } ### Link IP Mod Edit ###
</replace>

<edit file>
Sources/InstantMessage.pl
</edit file>

<search for>
	if ($iamadmin || $iamgmod && $gmod_access2{'ipban2'} eq 'on') { $imip = $imip; }
</search for>

<replace>
	### Link IP Mod Start ###
	if (-e("$vardir/link_ip.txt")) { require "$vardir/link_ip.txt"; }
	if ($linkip_im) { $iplink = qq~<a href="$ip_util$imip" target="_blank" style="text-decoration: underline;">$imip</a>~; }
	else { $iplink = $imip; }
	### Link IP Mod End ###
	if ($iamadmin || $iamgmod && $gmod_access2{'ipban2'} eq 'on') { $imip = $iplink; } ### Link IP Mod Edit ###
</replace>

<edit file>
Sources/Poll.pl
</edit file>

<search for>
		$vote_date = &timeformat($vote_date);
		$yymain .= qq~
</search for>

<add before>
	    ### Link IP Mod Start ###
	    if (-e("$vardir/link_ip.txt")) { require "$vardir/link_ip.txt"; }
	    if ($linkip_vv) { $iplink = qq~<a href="$ip_util$voters_ip" target="_blank" style="text-decoration: underline;">$voters_ip</a>~; }
	    else { $iplink = $voters_ip; }
	    ### Link IP Mod End ###
</add before>

<search for>
          <td class="windowbg2" align="center">$voters_ip</td>
</search for>

<replace>
          <td class="windowbg2" align="center">$iplink</td>
</replace>

<edit file>
Sources/Profile.pl
</edit file>

<search for>
		<td align="left">$userlastim<br /><br /></td>
	</tr>~;
</search for>

<add after>
	### Link IP Mod Start ###
	if (-e("$vardir/link_ip.txt")) { require "$vardir/link_ip.txt"; }
	if ($linkip_ae && $iamadmin || $linkip_ae && $iamgmod && $gmod_access2{'ipban2'} eq "on") {
	    &LoadLanguage('LinkIP');
        if (${$uid.$user}{'lastips'}) {
		    ($lastip_one, $lastip_two, $lastip_three) = split (/\|/, ${$uid.$user}{'lastips'});
		     if ($lastip_one) { $last_ip = qq~<a href="$ip_util$lastip_one" target="_blank" style="text-decoration: underline;">$lastip_one</a><br />~; }
		     if ($lastip_two) { $last_ip .= qq~<a href="$ip_util$lastip_two" target="_blank" style="text-decoration: underline;">$lastip_two</a><br />~; }
		     if ($lastip_three) { $last_ip .= qq~<a href="$ip_util$lastip_three" target="_blank" style="text-decoration: underline;">$lastip_three</a><br />~; }
	    }
	$showProfile .= qq~
	<tr class="windowbg">
		<td width="320" align="left"><b>$linkip_txt{'22'}:</b></td>
		<td align="left">$last_ip</td>
	</tr>
	<tr class="windowbg">
	    <td width="320" align="left"><b>$linkip_txt{'23'}: (<a href="$ip_util$lastip_one" target="_blank" style="font-weight: bold; text-decoration: underline;">$lastip_one</a>)</b></td>
	    <td align="left">
		<a href="http://www.afrinic.net/cgi-bin/whois?searchtext=$lastip_one" target="_blank">$linkip_txt{'24'}</a><br />
		<a href="http://wq.apnic.net/apnic-bin/whois.pl?searchtext=$lastip_one" target="_blank">$linkip_txt{'25'}</a><br />
		<a href="http://ws.arin.net/whois/?queryinput=$lastip_one" target="_blank">$linkip_txt{'26'}</a><br />
		<a href="http://whois.domaintools.com/$lastip_one" target="_blank">$linkip_txt{'10'}</a><br />
		<a href="http://www.geobytes.com/Iplocator.htm?GetLocation&ipaddress=$lastip_one" target="_blank">$linkip_txt{'11'}</a><br />
		<a href="http://www.ip-adress.com/whois/$lastip_one" target="_blank">$linkip_txt{'12'}</a><br />
		<a href="http://lacnic.net/cgi-bin/lacnic/whois?query=$lastip_one" target="_blank">$linkip_txt{'27'}</a><br />
		<a href="http://www.db.ripe.net/whois?searchtext=$lastip_one" target="_blank">$linkip_txt{'13'}</a><br />
		</td>
	</tr>~;
	}
	### Link IP Mod End ###
</add after>

<search for>
			if ($ip_one) { $ip_ban_options = qq~$ip_one<br />$banlink_one <br />~; }
			if ($ip_two) { $ip_ban_options .= qq~$ip_two<br />$banlink_two <br />~; }
			if ($ip_three) { $ip_ban_options .= qq~$ip_three<br />$banlink_three <br />~; }
</search for>

<replace>
            ### Link IP Mod Start ###
            if (-e("$vardir/link_ip.txt")) { require "$vardir/link_ip.txt"; }
            if ($linkip_mp) {
                $iplink_one = qq~<a href="$ip_util$ip_one" target="_blank" style="text-decoration: underline;">$ip_one</a>~;
                $iplink_two = qq~<a href="$ip_util$ip_two" target="_blank" style="text-decoration: underline;">$ip_two</a>~;
                $iplink_three = qq~<a href="$ip_util$ip_three" target="_blank" style="text-decoration: underline;">$ip_three</a>~;
            } else {
                $iplink_one = $ip_one;
                $iplink_two = $ip_two;
                $iplink_three = $ip_three;
            }
            ### Link IP Mod End ###
            
            if ($ip_one) { $ip_ban_options = qq~$iplink_one<br />$banlink_one <br />~; } ### Link IP Mod Edit ###
			if ($ip_two) { $ip_ban_options .= qq~$iplink_two<br />$banlink_two <br />~; } ### Link IP Mod Edit ###
			if ($ip_three) { $ip_ban_options .= qq~$iplink_three<br />$banlink_three <br />~; } ### Link IP Mod Edit ###
</replace>